# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/28
import argparse
import os
import sys
import time
sys.path.append(os.getcwd())
from common.common import Common
from gongzhonghao.gongzhonghao_follow.gongzhonghao_follow import GongzhonghaoFollow


class Main:
    @classmethod
    def main(cls, log_type, crawler, env):
        while True:
            try:
                if env == "dev":
                    oss_endpoint = "out"
                else:
                    oss_endpoint = "inner"
                Common.logger(log_type, crawler).info('开始抓取公众号视频\n')
                GongzhonghaoFollow.get_all_videos(log_type=log_type,
                                                  crawler=crawler,
                                                  oss_endpoint=oss_endpoint,
                                                  env=env)
                Common.del_logs(log_type, crawler)
                GongzhonghaoFollow.begin = 0
                Common.logger(log_type, crawler).info('休眠 8 小时\n')
                time.sleep(3600*8)
            except Exception as e:
                Common.logger(log_type, crawler).info(f"公众号抓取异常:{e}\n")


if __name__ == '__main__':
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    Main.main(log_type=args.log_type,
              crawler=args.crawler,
              env=args.env)