# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/2/17
import argparse
import os
import sys
import time

sys.path.append(os.getcwd())
from common.common import Common
from xigua.xigua_follow.xigua_follow import Follow
from common.feishu import Feishu


def main(log_type, crawler, strategy, oss_endpoint, env, machine):
    try:
        Common.logger(log_type, crawler).info('开始抓取 西瓜视频 定向榜\n')
        Follow.get_follow_videos(log_type, crawler, strategy, oss_endpoint, env, machine)
        Common.del_logs(log_type, crawler)
        Common.logger(log_type, crawler).info('抓取完一轮，休眠 1 分钟\n')
    except Exception as e:
        Common.logger(log_type, crawler).info(f"西瓜视频异常，触发报警:{e}\n")
        Feishu.bot(log_type, crawler, f"{e}")


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--strategy')  ## 添加参数
    parser.add_argument('--our_uid')  ## 添加参数
    parser.add_argument('--oss_endpoint')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    parser.add_argument('--machine')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    # print(args)
    main(log_type=args.log_type,
         crawler=args.crawler,
         strategy=args.strategy,
         oss_endpoint=args.oss_endpoint,
         env=args.env,
         machine=args.machine)