# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/2/17
import argparse
import os
import sys

sys.path.append(os.getcwd())
from common.common import Common
from xigua.xigua_follow.xigua_follow_scheduling import SchedulingFollow
# from common.feishu import Feishu


def main(log_type, crawler, task, oss_endpoint, env):
    task = dict(eval(task))
    Common.logger(log_type, crawler).info(f"{type(task)}\n")
    Common.logger(log_type, crawler).info(f"{task}\n")
    try:
        Common.logger(log_type, crawler).info('开始抓取 西瓜视频 定向榜\n')
        SchedulingFollow.get_follow_videos(log_type=log_type,
                                           crawler=crawler,
                                           task=task,
                                           oss_endpoint=oss_endpoint,
                                           env=env)
        Common.del_logs(log_type, crawler)
        Common.logger(log_type, crawler).info('抓取任务结束\n')
    except Exception as e:
        Common.logger(log_type, crawler).info(f"西瓜视频异常，触发报警:{e}\n")
        # Feishu.bot(log_type, crawler, f"{e}")


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--strategy')  ## 添加参数
    parser.add_argument('--task')  ## 添加参数
    parser.add_argument('--oss_endpoint')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    # parser.add_argument('--machine')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    main(log_type=args.log_type,
         crawler=args.crawler,
         task=args.task,
         oss_endpoint=args.oss_endpoint,
         env=args.env)